{ Sprite Editor V0.1-Turbo Pascal source file                               }
{ Created 01/25/2004, Modified 01/28/2004                                   }
{ Copyright (C) 2004  Mikael Turgeon                                        }
{                                                                           }
{ This program is free software; you can redistribute it and/or modify      }
{ it under the terms of the GNU General Public License as published by      }
{ the Free Software Foundation; either version 2 of the License, or         }
{ (at your option) any later version.                                       }
{                                                                           }
{ This program is distributed in the hope that it will be useful,           }
{ but WITHOUT ANY WARRANTY; without even the implied warranty of            }
{ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             }
{ GNU General Public License for more details.                              }
{                                                                           }
{ You should have received a copy of the GNU General Public License         }
{ along with this program; if not, write to the Free Software               }
{ Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA }

program sprtedit;
uses graph,crt;
var spritewidth,spriteheight:integer;
    sprite:array[1..32,1..99] of boolean;
    gd,gm,forvar1,forvar2,x,y,oldx,oldy:integer;
    height,width,maxheight:integer;
    pixelcolor:word;
    key:char;
    filename,readstring,filename2:string;
    files:text;
    fileloaded:boolean;
const hex:array[0..15] of char=('0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F');

function converttohex(startbit,row:integer):string;
var temp2:integer;
  begin
    if sprite[startbit,row]=true then
      temp2:=8
        else
          temp2:=0;
    if sprite[startbit+1,row]=true then
      temp2:=temp2+4;
    if sprite[startbit+2,row]=true then
      temp2:=temp2+2;
    if sprite[startbit+3,row]=true then
      temp2:=temp2+1;
    converttohex:=hex[temp2];
  end;

procedure makehexsprite(bitlevel:integer);
  begin
    assign(files,filename2);
    rewrite(files);
    write(files,'{0x');
    write('{0x');
      for forvar2:=1 to spriteheight do
        begin
          for forvar1:=1 to (bitlevel div 4) do
            begin
              write(files,converttohex((forvar1*4)-3,forvar2));
              write(converttohex((forvar1*4)-3,forvar2));
            end;
          if forvar2<>spriteheight then
            begin
              write(files,',0x');
              write(',0x');
            end
              else
                begin
                  write(files,'}');
                  write('}');
                end;
        end;
    close(files);
  end;

procedure erasemarker(xx,yy:integer);
  var drawmode:word;
  begin
    drawmode:=black;
    if sprite[xx,yy]=true then
      drawmode:=white;
    putpixel((xx*5)+27-5,(yy*4)+4-4,drawmode);
    putpixel((xx*5)+28-5,(yy*4)+4-4,drawmode);
  end;

procedure putmarker(xx,yy:integer);
  var drawmode:word;
  begin
    drawmode:=white;
    if sprite[xx,yy]=true then
      drawmode:=black;
    putpixel((xx*5)+22,(yy*4),drawmode);
    putpixel((xx*5)+23,(yy*4),drawmode);
  end;

procedure invertbox(xx,yy:integer);
  var drawmode:word;
  begin
    drawmode:=white;
    if sprite[xx,yy]=true then
      drawmode:=black;
      setcolor(drawmode);
    rectangle((xx*5)+21,(yy*4)-1,(xx*5)+24,(yy*4)+1);
    setcolor(1);
    if sprite[xx,yy]=false then
      sprite[xx,yy]:=true
        else
          sprite[xx,yy]:=false;
  end;

procedure drawloaded(xx,yy:integer);
  var drawmode:word;
  begin
    drawmode:=black;
    if sprite[xx,yy]=true then
      drawmode:=white;
    setcolor(drawmode);
    setfillstyle(1,drawmode);
    bar((xx*5)+21,(yy*4)-1,(xx*5)+24,(yy*4)+1);
    setcolor(black);
  end;

procedure createpreview;
  begin
    for forvar1:=1 to spritewidth do
      for forvar2:=1 to spriteheight do
        if sprite[forvar1,forvar2]=true then
          putpixel(210+forvar1,130+forvar2,white)
            else
              putpixel(210+forvar1,130+forvar2,black);
  end;

begin
  if getmaxy<250 then
    maxheight:=49 else
      maxheight:=99;
repeat
  clrscr;
  for forvar1:=1 to 32 do
    for forvar2:=1 to 99 do
      sprite[forvar1,forvar2]:=false;
  pixelcolor:=white;
  x:=1;
  y:=1;
  key:=#0;
  fileloaded:=false;
  writeln('Welcome to Sprite Editor!');
  writeln;
  write('Load an Existing Sprite? (Y/N):');
  key:=readkey;
  if upcase(key)='N' then
    begin
      repeat
        writeln('Create a New Sprite.');
        write('Width (8,16 or 32): ');
        readln(spritewidth);
        writeln;
        if (spritewidth<>8) and (spritewidth<>16) and (spritewidth<>32) then
          begin
            writeln('Sorry, ',spritewidth,' is an invalid sprite width!');
            writeln;
          end;
      until (spritewidth=8) or (spritewidth=16) or (spritewidth=32);
      repeat
        write('Height (1-',maxheight,'): ');
        readln(spriteheight);
        writeln;
        if (spriteheight<1) or (spriteheight>maxheight) then
          begin
            writeln('Sorry, ',spriteheight,' is an invalid sprite height!');
            writeln;
          end;
      until (spriteheight>0) and (spriteheight<maxheight+1);
    end
      else if upcase(key)='Y' then
        begin
          fileloaded:=true;
          Writeln;
          Write('enter the name of the .SPR file to load:');
          readln(filename);
          filename2:=filename+'.spr';
          assign(files,filename2);
          reset(files);
          readln(files,spritewidth);
          readln(files,spriteheight);
          for forvar1:=1 to spriteheight do
            for forvar2:=1 to spritewidth do
              begin
                readln(files,readstring);
                if readstring='1' then
                  sprite[forvar2,forvar1]:=true;
              end;
          close(files);
        end;
  gd:=detect;
  initgraph(gd,gm,'');
  if graphresult<>grOk then
    halt(1);
  rectangle(15,0,370,getmaxy);
  for height:=0 to spriteheight do
     line(25,(height*4)+2,(spritewidth*5)+25,(height*4)+2);
  for width:=0 to spritewidth do
     line((width*5)+25,2,(width*5)+25,(spriteheight*4)+2);
  outtextxy(200,10,'Sprite Editor');
  outtextxy(200,20,'by Mikael Turgeon');
  outtextxy(200,40,'ARROWS=move cursor');
  outtextxy(200,50,'SPACE =change pixel');
  outtextxy(200,60,'ENTER =finish, save');
  outtextxy(200,70,'ESC   =quit, no save');
  outtextxy(200,110,'Preview:');
  if sprite[1,1]=true then
    pixelcolor:=black;
  setfillstyle(1,1);
  if fileloaded then
    begin
      for forvar1:=1 to spritewidth do
        for forvar2:=1 to spriteheight do
          if sprite[forvar1,forvar2]=true then
            drawloaded(forvar1,forvar2);
      createpreview;
    end;
  putpixel(27,4,pixelcolor);
  putpixel(28,4,pixelcolor);
  repeat
    oldx:=x;
    oldy:=y;
    key:=readkey;
    if key=#0 then
      key:=readkey;
    if key='K' then
      if (x-1<>0) then
        begin
          x:=x-1;
          erasemarker(oldx,oldy);
          putmarker(x,y);
        end;
    if key='M' then
      if (x+1<>spritewidth+1) then
        begin
          x:=x+1;
          erasemarker(oldx,oldy);
          putmarker(x,y);
        end;
    if key='H' then
      if (y-1<>0) then
        begin
          y:=y-1;
          erasemarker(oldx,oldy);
          putmarker(x,y);
        end;
    if key='P' then
      if (y+1<>spriteheight+1) then
        begin
          y:=y+1;
          erasemarker(oldx,oldy);
          putmarker(x,y);
        end;
    if key=' ' then
      begin
        invertbox(x,y);
        createpreview;
        putmarker(x,y);
      end;
  until (key=#27) or (key=#13);
  closegraph;
  if key=#27 then
    begin
      closegraph;
      halt(0);
    end;
  clrscr;
  if fileloaded then
    writeln('File has been edited: ',filename);
  write('Enter a filename to export your sprite to: ');
  readln(filename);
  filename2:=filename+'.txt';
  Writeln('The following sprite has been saved in the file ',filename,':');
  writeln;
  makehexsprite(spritewidth);
  filename2:=filename+'.spr';
  assign(files,filename2);
  rewrite(files);
  writeln(files,spritewidth);
  writeln(files,spriteheight);
  for forvar1:= 1 to spriteheight do
    for forvar2:= 1 to spritewidth do
      begin
        gotoxy(forvar2,forvar1+2);
        if sprite[forvar2,forvar1]=true then
          writeln(files,'1')
            else
              writeln(files,'0');
      end;
  close(files);
  gotoxy(1,18);
  write('Continue with another Sprite? (Y/N):');
  key:=readkey;
until upcase(key)<>'Y';
end.